# Find required OpenEXR libraries and dependencies
#
# Stephan Meister, <stephan.meister@iwr.uni-heidelberg.de>, Sep 2013
#
# defined variables
#  EXR_LIBRARIES, link libraries to use
#  EXR_INCLUDE_DIRS, location of the IlmImf and OpenEXR include files
#  EXR_FOUND.

# OpenEXR depends on ZLIB
find_package(ZLIB REQUIRED)

if(ZLIB_FOUND)
  find_path(EXR_INCLUDE_DIR ImfIO.h
  /usr/include/OpenEXR
  )

 find_library(IlmImf_LIBRARY IlmImf )
 find_library(Iex_LIBRARY Iex )
 find_library(Half_LIBRARY Half )
 find_library(IlmThread_LIBRARY IlmThread )
 find_library(Imath_LIBRARY Imath )

 if (IlmImf_LIBRARY AND Iex_LIBRARY AND Half_LIBRARY AND IlmThread_LIBRARY AND Imath_LIBRARY AND EXR_INCLUDE_DIR)
      set(EXR_INCLUDE_DIRS ${EXR_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR} )
      set(EXR_LIBRARIES ${IlmImf_LIBRARY} ${Iex_LIBRARY} ${Half_LIBRARY} ${IlmThread_LIBRARY} ${Imath_LIBRARY} ${ZLIB_LIBRARY})
 endif ()
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(EXR
                                  REQUIRED_VARS IlmImf_LIBRARY Iex_LIBRARY Half_LIBRARY IlmThread_LIBRARY Imath_LIBRARY EXR_INCLUDE_DIR)

mark_as_advanced(EXR_INCLUDE_DIRS EXR_LIBRARIES)
