/*  Copyright (C) 2010 Stephan Meister

    This file is part of Charon.

    Charon is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Charon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file FileReaderExr.h
 *  Declaration of the parameter class FileReaderExr.
 *  \author Stephan Meister
 *  \date 23.03.2012
 */

#ifndef _FILEREADEREXR_H_
#define _FILEREADEREXR_H_

#if defined(MSVC) && defined(HANDLE_DLL)
#ifdef filereaderexr_EXPORTS
/// Visual C++ specific code
#define filereaderexr_DECLDIR __declspec(dllexport)
#else
#define filereaderexr_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else /* No DLL handling or GCC */
/// Not needed with GCC
#define filereaderexr_DECLDIR
#endif

#include <charon-core/ParameteredObject.hxx>
#include <CImg.h>

/// dump data as binary stream
template <typename T>
class filereaderexr_DECLDIR FileReaderExr :
		public TemplatedParameteredObject<T> {
public:
	
	Parameter < std::string > _filenames ;

	Parameter < std::string > _channels ;

	/// input image
	OutputSlot < cimg_library::CImgList<T> > _out;

	/// create a new FileReaderExr object
	/// \param name          Instance name
	FileReaderExr(const std::string& name);

	/// Update object.
	virtual void execute();


};

#endif // _DISP2DEPTH_H_



