

#ifndef LUX_ANTILAMBERTIAN_H
#define LUX_ANTILAMBERTIAN_H
// antiLambertian.h*
#include "lux.h"
#include "bxdf.h"
#include "spectrum.h"

namespace lux
{

class  AntiLambertian : public BxDF {
public:
	// AntiLambertian Public Methods
	AntiLambertian(const SWCSpectrum &reflectance)
		: BxDF(BxDFType(BSDF_REFLECTION | BSDF_DIFFUSE)),
		  R(reflectance) {
	}
	virtual ~AntiLambertian() { }
	virtual void F(const SpectrumWavelengths &sw, const Vector &wo,
		const Vector &wi, SWCSpectrum *const f) const;
	bool SampleF(const SpectrumWavelengths &sw, const Vector &wo,
		Vector *wi, float u1, float u2, SWCSpectrum *const f_,
		float *pdf, float *pdfBack, bool reverse) const;
	virtual SWCSpectrum rho(const SpectrumWavelengths &sw, const Vector &,
		u_int, float *) const { return R; }
	virtual SWCSpectrum rho(const SpectrumWavelengths &sw, u_int,
		float *) const { return R; }
private:
	// AntiLambertian Private Data
	SWCSpectrum R;
};

}//namespace lux

#endif // LUX_LAMBERTIAN_H

